﻿Option Explicit On
Imports System
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Public Class $safeprojectname$

    Sub GetSerialPortNames()
        For Each sp As String In My.Computer.Ports.SerialPortNames
            cmbPort.Items.Add(sp)
        Next
    End Sub
    Dim pause As Integer = 0
    Dim period As Integer = 0
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        GetSerialPortNames()


    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
 
            Try
            com.BaudRate = "9600"
                com.PortName = cmbPort.SelectedItem.ToString
                com.Open()
                If com.IsOpen Then
                    btnConnect.Enabled = False
                    cmbPort.Enabled = False

                btnDisconnect.Enabled = True
                Me.Hide()
                End If
            Catch
                com.Close()
        End Try

    End Sub
    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisconnect.Click
        Try
            com.Close()
            btnConnect.Enabled = True
            btnDisconnect.Enabled = False
            cmbPort.Enabled = True

            Exit Sub
        Catch
            MessageBox.Show("Some kind of problem.")
        End Try
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Try
            com.Close()
            btnConnect.Enabled = True
            btnDisconnect.Enabled = False
            cmbPort.Enabled = True

            Exit Sub
        Catch
            MessageBox.Show("Some kind of problem.")
        End Try
    End Sub

    Sub ShowString(ByVal myString As String)
        txtIn.Refresh()
        txtIn.AppendText(myString)
    End Sub

    Delegate Sub myMethodDelegate(ByVal [text] As String)
    Dim myDelegate As New myMethodDelegate(AddressOf ShowString)

    Private Sub com_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles com.DataReceived
        Dim str As String = com.ReadLine
        Invoke(myDelegate, str)
        process_key(str)
    End Sub

    Const VK_VOLUME_MUTE = &H8
    Private Declare Sub keybd_event Lib "user32" ( _
    ByVal bVk As Byte, ByVal bScan As Byte, _
    ByVal dwFlags As Long, ByVal dwExtraInfo As Long)


    '
    '       Trigger events section 
    '       Change the comparision value according to your $safeprojectname$
    '       e.g. If str = 1124 Or str = 66270 Then
    '                   Do something
    '            End if
    '        assume your $safeprojectname$ sends 'xxxx' and 'XXXXX' on pressing power button
    '       then change the statement to:
    '          e.g. If str = xxxx Or str = XXXXX Then
    '                   Do something
    '            End if
    '



    Function process_key(ByVal str As String)

        If str = 1184 Or str = 66720 Then
            Process.Start("C:\Windows\System32\SndVol.exe") 'To call volume panel
        ElseIf str = 1116 Or str = 66659 Then
            send_key("{Enter}")                             'To press enter
        ElseIf str = 1112 Or str = 66648 Then
            send_key("{UP}")                                'To press up arrow key
        ElseIf str = 1113 Or str = 66649 Then
            send_key("{DOWN}")                              'To press down arrow key
        ElseIf str = 1115 Or str = 66651 Then
            send_key("{RIGHT}")                             'To press right arrow key
        ElseIf str = 1114 Or str = 66650 Then
            send_key("{LEFT}")                              'To press left arrow key
        ElseIf str = 1223 Or str = 66759 Then
            send_key("^{ESC}")                              'To press Windows key
        ElseIf str = 1056 Or str = 66592 Then
            send_key("{TAB}")                               'To press TAB key
        ElseIf str = 1057 Or str = 66593 Then
            send_key("+{TAB}")                              'To get focus to previous item / opposite of TAB
        ElseIf str = 1073 Or str = 66609 Then
            send_key("%{F4}")                               'To press ALT+F4 to close any application
        ElseIf str = 1184 Or str = 66720 Then
            send_key("0")                                   'To press noumerical 0 key
        ElseIf str = 1025 Or str = 66561 Then
            send_key("1")                                   'To press noumerical 1 key
        ElseIf str = 1026 Or str = 66562 Then
            send_key("2")                                   'To press noumerical 2 key
        ElseIf str = 1027 Or str = 66563 Then
            send_key("3")                                   'To press noumerical 3 key
        ElseIf str = 1028 Or str = 66564 Then
            send_key("4")                                   'To press noumerical 4 key
        ElseIf str = 1029 Or str = 66565 Then
            send_key("5")                                   'To press noumerical 5 key
        ElseIf str = 1030 Or str = 66566 Then
            send_key("6")                                   'To press noumerical 6 key
        ElseIf str = 1031 Or str = 66567 Then
            send_key("7")                                   'To press noumerical 7 key
        ElseIf str = 1032 Or str = 66568 Then
            send_key("8")                                   'To press noumerical 8 key
        ElseIf str = 1033 Or str = 66569 Then
            send_key("9")                                   'To press noumerical 9 key
        ElseIf str = 1155 Or str = 66691 Then
            send_key("{BS}")                                'To press backspace and escape key
            send_key("{ESC}")                               'To get back to previous window
        ElseIf str = 1039 Or str = 66575 Then
            send_key("%{ENTER}")                            'To open properties dialog box of any selected file
        ElseIf str = 1233 Or str = 66769 Then
            send_key("%F")                                  'To open file menu
        ElseIf str = 1090 Or str = 66626 Then
            send_key("+{F10}")                              'To make a right click
        ElseIf str = 1154 Or str = 66690 Then
            Process.Start("C:\Windows\System32\control.exe") 'To call control panel
        ElseIf str = 1037 Or str = 66573 Then
            keybd_event(VK_VOLUME_MUTE, 0, 1, 0)            'To mute the windows sound
        ElseIf str = 1271 Or str = 66807 Then
            toggle()                                        'To enable aero flip 3D to jump through minimized windows
        ElseIf str = 1068 Or str = 66604 Then
            keybd_event(179, 0, 1, 0)                       'To play/pause any media file in any media player
        ElseIf str = 1099 Or str = 66635 Then
            Me.Show()                                       'To show this application
        End If
        Return 0                                            'As you connect the serial port, it disappears

    End Function



    Function toggle()
        Dim p As New ProcessStartInfo
        p.FileName = "C:\Windows\System32\rundll32.exe"
        p.Arguments = "dwmapi #105"
        p.WindowStyle = ProcessWindowStyle.Hidden
        Process.Start(p)
        Return 0
    End Function

    Function send_key(ByVal key As String, Optional ByVal p As Integer = 1000)

        Timer1.Enabled = True

        period = p
        My.Computer.Keyboard.SendKeys(key, True)
        Return 0
    End Function

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If pause < period Then
            pause += 1
        Else
            pause = 0
            Timer1.Enabled = False
        End If
    End Sub

End Class


